// {GotLag?}'s GUI Toolbar
// * Created to simplify the Creation, Loading, and Saving of Starsiege GUIs.
// * IF YOU USE ANY PART OF THIS CODE, GIVE ME SOME CREDIT SOMEWHERE IN YOUR CODE AND/OR README FILE.
//
// Copyright (c) 2002 Robert "{GotLag?}" McAfee, All Rights Reserved.
// All trademarks are properties of their respective owners.

// FEATURES:
// * Normal GUI Toolbar Stuff
// * New Control
// * New/Save/Load GUI
// * Load/Save Control Group
// * Auto Save
// * Treeview

if($GLEdit::Running != "true")
{
$GLEdit::Canvas = "SimCanvas";

// -----------------
// UTIL

function GLEdit::WinMouse()
{
if(IsObject($GLEdit::Canvas))
{
inputDeactivate("mouse0");
windowsMouseEnable($GLEdit::Canvas);
}
}

function GLEdit::GuiMouse()
{
if(IsObject($GLEdit::Canvas))
{
inputActivate("mouse0");
windowsMouseDisable($GLEdit::Canvas);
}
}

// -----------------
// TREE

function GLEdit::Tree()
{
if(IsObject($GLEdit::Canvas))
{
$GLEdit::Tree = "GLTree";
SimTreeCreate($GLEdit::Tree,$GLEdit::Canvas);

//These would be used for mission stuff.
SimTreeRegBitmaps($GLEdit::Tree,"Herc.bmp","HercOpen.bmp");
SimTreeRegClass($GLEdit::Tree,"Herc",8,9);
SimTreeRegBitmaps($GLEdit::Tree,"static.bmp","staticOpen.bmp");
SimTreeRegClass($GLEdit::Tree,"StaticShape",10,11);
SimTreeRegBitmaps($GLEdit::Tree,"interior.bmp","interiorOpen.bmp");
SimTreeRegClass($GLEdit::Tree,"StaticInterior",12,13);
SimTreeRegBitmaps($GLEdit::Tree,"dropPt.bmp","dropPtOpen.bmp");
SimTreeRegClass($GLEdit::Tree,"DropPoint",14,15);

//Folders
SimTreeRegBitmaps($GLEdit::Tree,"folderClosed.bmp","folderopen.bmp");
SimTreeRegClass($GLEdit::Tree,"SimSet",16,17);
SimTreeRegClass($GLEdit::Tree,"SimGroup",16,17);

//Canvas
SimTreeRegBitmaps($GLEdit::Tree,"GUI.bmp","GUIOpen.bmp");
SimTreeRegClass($GLEdit::Tree,"SimGui",18,19);

SimTreeRegScript($GLEdit::Tree,"About","LocalMessageBox(\"{GotLag?}'s Toolbar and Tree View\nCode Copyright (c) 2002 {GotLag?}\");");

SimTreeAddSet("GLTree","NamedGuiSet");
}
}

// -----------------
// TOOLBAR
function GLEdit::AutoSave()
{
if($GLEdit::AutoSaveTime != "")
{
GuiSaveContentCtrl(simCanvas, "~Autosave.gui");
schedule("GLEdit::AutoSave();",$GLEdit::AutoSaveTime);
}
}

function GLEdit::AutoSaveToggle()
{
if($GLEdit::AutoSave == false)
{
$GLEdit::AutoSaveTime = 1;
EditBox("AutoSave Time","Enter AutoSave Interval in Minutes:","GLEdit::AutoSaveTime");
if($DlgResult == "[ok]")
{
$GLEdit::AutoSave = true;
$GLEdit::AutoSaveTime *= 60;
GLEdit::AutoSave();
}
}
else
{
$GLEdit::AutoSaveTime="";
$GLEdit::AutoSave = false;
}
}

function GLEdit::NewCtrl()
{
EditBox("Object Class","Enter Object Classname (ex. SimGui::SimpleText)","GLEdit::NewCtrl");
GuiEditNewControl(simCanvas, $GLEdit::NewCtrl);
}

function GLEdit::NewGui()
{
GuiLoadContentCtrl(simCanvas, "GL_NewGui.gui");
}

function GLEdit::LoadGui()
{
OpenFile("GLEdit::File","GUI (*.gui)","*.gui","Dialog (*.dlg)","*.dlg");
if($dlgResult == "[ok]" && IsFile($GLEdit::File))
{
GuiLoadContentCtrl(simCanvas, $GLEdit::File);
}
}

function GLEdit::SaveGui()
{
SaveFileAs("GLEdit::File","GUI (*.gui)","*.gui","Dialog (*.dlg)","*.dlg");
if($dlgResult == "[ok]")
{
GuiSaveContentCtrl(simCanvas, "~Autosave.gui");
}
}

function GLEdit::LoadGroup()
{
OpenFile("GLEdit::File","Control Group (*.grp)","*.grp");
if($dlgResult == "[ok]" && IsFile($GLEdit::File))
{
GuiLoadSelection(simCanvas, $GLEdit::File);
}
}

function GLEdit::SaveGroup()
{
SaveFileAs("GLEdit::File","Control Group (*.grp","*.grp");
if($dlgResult == "[ok]")
{
GuiSaveSelection(simCanvas, $GLEdit::File);
}
}

function GLEdit::ToolbarClose()
{
SetMainWindow(SimCanvas);
ConfirmBox("Close","Are you sure you want to close the toolbar?");
if($dlgResult == "[yes]")
{
if(isobject($GLEdit::Scheduler)) { deleteobject($GLEdit::Scheduler); }
if(isobject("ObjectInspector")) { deleteobject("ObjectInspector"); }
if(isobject("GuiInspector")) { deleteobject("GuiInspector"); }
if(isobject($GLEdit::Tree)) { deleteobject($GLEdit::Tree); }
deleteobject($GLEdit::Toolbar);
deleteobject($GLEdit::ToolIcons);
GLEdit::GuiMouse();
deletefunctions("GLEdit::*");
deletevariables("$GLEdit::*");
}
}

function GLEdit::Toolbar()
{
// Left | Right | Center || Top | Bottom || V. Space | H. Space || Front | Back || Edit || Close
// | Status Window for Help |

$GLEdit::ToolIcons = newObject("GL_TOOLBAR_ICONS", SimVolume, "GL_GUI_Toolbar.vol");

if($Server::Hostname == "")
$GLEdit::Scheduler = newObject("",SimConsoleScheduler);

$GLEdit::Toolbar = "GLEditToolbar";
NewToolWindow($GLEdit::Toolbar,SimCanvas,1);
addStatusbar($GLEdit::Toolbar,500);

addToolButton($GLEdit::Toolbar, LeftJustify, "tb_leftJustify.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, LeftJustify, "GuiJustify($GLEdit::Canvas, 0);");
setButtonHelp($GLEdit::Toolbar, LeftJustify, "Align left sides of controls.");

addToolButton($GLEdit::Toolbar, RightJustify, "tb_rightJustify.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, RightJustify, "GuiJustify($GLEdit::Canvas, 2);");
setButtonHelp($GLEdit::Toolbar, RightJustify, "Align right sides of controls.");

addToolButton($GLEdit::Toolbar, CenterJustify, "tb_centerJustify.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, CenterJustify, "GuiJustify($GLEdit::Canvas, 1);");
setButtonHelp($GLEdit::Toolbar, CenterJustify, "Align centers of controls.");

addToolGap($GLEdit::Toolbar, gap1);

addToolButton($GLEdit::Toolbar, TopAlign, "tb_topAlign.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, TopAlign, "GuiJustify($GLEdit::Canvas, 3);");
setButtonHelp($GLEdit::Toolbar, TopAlign, "Align tops of controls.");

addToolButton($GLEdit::Toolbar, BottomAlign, "tb_bottomAlign.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, BottomAlign, "GuiJustify($GLEdit::Canvas, 4);");
setButtonHelp($GLEdit::Toolbar, BottomAlign, "Align bottoms of controls.");

addToolGap($GLEdit::Toolbar, gap2);

addToolButton($GLEdit::Toolbar, AutoVSpace, "tb_vSpace.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, AutoVSpace, "GuiJustify($GLEdit::Canvas, 5);");
setButtonHelp($GLEdit::Toolbar, AutoVSpace, "Equally space controls vertically.");

addToolButton($GLEdit::Toolbar, AutoHSpace, "tb_hSpace.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, AutoHSpace, "GuiJustify($GLEdit::Canvas, 6);");
setButtonHelp($GLEdit::Toolbar, AutoHSpace, "Equally space controls horizontally.");

addToolGap($GLEdit::Toolbar, gap3);

addToolButton($GLEdit::Toolbar, BringToFront, "tb_front.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, BringToFront, "GuiBringToFront($GLEdit::Canvas);");
setButtonHelp($GLEdit::Toolbar, BringToFront, "Bring the selected control(s) to the front.");

addToolButton($GLEdit::Toolbar, SendToBack, "tb_back.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, SendToBack, "GuiSendToBack($GLEdit::Canvas);");
setButtonHelp($GLEdit::Toolbar, SendToBack, "Send the selected control(s) to the back.");

addToolGap($GLEdit::Toolbar, gap4);

addToolButton($GLEdit::Toolbar, EditMode, "tb_edit.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, EditMode, "GuiEditMode($GLEdit::Canvas);");
setButtonHelp($GLEdit::Toolbar, EditMode, "Toggle GUI Edit Mode.");

addToolGap($GLEdit::Toolbar, gap5);

addToolButton($GLEdit::Toolbar, GLAutoSave, "tb_auto.bmp", 0, 1);
setToolCommand($GLEdit::Toolbar, GLAutoSave, "GLEdit::AutoSaveToggle();", "GLEdit::AutoSaveToggle();");
setButtonHelp($GLEdit::Toolbar, GLAutoSave, "Turn this on to automatically save a backup of your GUI every few minutes.");

addToolGap($GLEdit::Toolbar, gap6);

addToolButton($GLEdit::Toolbar, GLTree, "tb_tree.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, GLTree, "GLEdit::Tree();");
setButtonHelp($GLEdit::Toolbar, GLTree, "Display the GUI in a treeview.");

addToolGap($GLEdit::Toolbar, gap7);

addToolButton($GLEdit::Toolbar, GLNewCtrl, "tb_newc.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, GLNewCtrl, "GLEdit::NewCtrl();");
setButtonHelp($GLEdit::Toolbar, GLNewCtrl, "Create a new Control.");

addToolGap($GLEdit::Toolbar, gap8);

addToolButton($GLEdit::Toolbar, GLNewGui, "tb_new.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, GLNewGui, "GLEdit::NewGui();");
setButtonHelp($GLEdit::Toolbar, GLNewGui, "Create a new GUI.");

addToolButton($GLEdit::Toolbar, GLLoadGui, "tb_load.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, GLLoadGui, "GLEdit::LoadGui();");
setButtonHelp($GLEdit::Toolbar, GLLoadGui, "Load an existing GUI.");

addToolButton($GLEdit::Toolbar, GLSaveGui, "tb_save.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, GLSaveGui, "GLEdit::SaveGui();");
setButtonHelp($GLEdit::Toolbar, GLSaveGui, "Save the current GUI.");

addToolGap($GLEdit::Toolbar, gap9);

addToolButton($GLEdit::Toolbar, GLLoadGroup, "tb_loadg.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, GLLoadGroup, "GLEdit::LoadGroup();");
setButtonHelp($GLEdit::Toolbar, GLLoadGroup, "Load an existing Control Group.");

addToolButton($GLEdit::Toolbar, GLSaveGroup, "tb_saveg.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, GLSaveGroup, "GLEdit::SaveGroup();");
setButtonHelp($GLEdit::Toolbar, GLSaveGroup, "Save the selected controls as a Control Group.");

addToolGap($GLEdit::Toolbar, gap10);

addToolButton($GLEdit::Toolbar, KillBar, "tb_killTB.bmp", 0, 0);
setToolCommand($GLEdit::Toolbar, KillBar, "GLEdit::ToolbarClose();");
setButtonHelp($GLEdit::Toolbar, KillBar, "Close {GotLag?}'s Editor Toolbar.");

addToolGap($GLEdit::Toolbar, gap11);

$GLEdit::AutoSave = false;
GUIInspect(SimCanvas);
SetMainWindow(SimCanvas);
$GLEdit::Running = true;
}

echo("Running {GotLag?}'s Toolbar...");
GLEdit::Toolbar();
}
else
echo("{GotLag?}'s GUI Toolbar is already running.");